java反常处理机制ITeye - 乐橙lc8

java反常处理机制ITeye

2019-01-12 19:01:06 | 作者: 涵涵 | 标签: 反常,处理,句子 | 浏览: 1847

java反常关键字有以下几个,分别为 try catch final throw throws
他们的界说分别为
try:  Opening exception-handling statement.
catch:  Captures the exception.
finally: Runs its code before terminating the program.
throws:  Lists the exceptions a method could throw.
Throw:  Transfers control of the method to the exception handler

java反常关键字的效果
try{}:try句子块
捕捉反常,会把有可能发作反常的代码写在try句子块中,
在履行过程中,假如代码发作反常,try句子块会捕捉反常,转交给
catch句子进行处理
catch(反常类型 目标名){}:
catch句子会依据try句子块捕捉反常的进行匹配,履行相应的
处理代码。
finally{}
不论是否发作反常都会履行的句子块;
用来开释一些必需求开释的资源。
throw
在办法里面向外抛出反常,需求运用throws或许try{}catch进行
处理操作。
能够运用throw创立一个新反常目标。
throws
throws是将反常抛给调用的当地。

2.Java中反常的分类
Throwable
Error:过错
过错一般是代码上无法进行修正的反常
Exception :反常
运行时反常:RuntimeException
NullPointerException
ArrayIndexOutOfBoundsException

强制反常
IOException
ClassNotFoundException
SocketException

对反常进行测验

public class Demo {

private static Demo d;

private static int[] array = new int[10];

public static void main(String[] args) {
try {
byZero();
}catch (Exception e) {
e.printStackTrace();//打印反常的仓库信息
}

try {
nullMethod();
} catch (Exception e) {
e.printStackTrace();
}

try {
indexMethod();
} catch (Exception e) {
e.printStackTrace();
}
}

public static void byZero() throws Exception {
try {
int i = 10 / 0;
} catch (ArithmeticException e) {
// throw new ArithmeticException("除数为0");
throw new Exception("除数为0");
}
}

public static void nullMethod() throws Exception {
try {
d.hashCode();
} catch (NullPointerException e) {
throw new Exception("空指针反常");
}
}

public static void indexMethod() throws Exception {
try {
array[-1] = 0;
} catch (ArrayIndexOutOfBoundsException e) {
throw new Exception("数组越界");
}
}

}
java反常机制的效果

1.能够在不停止程序的情况下找到过错并剖析
2.把过错信息扔出来处理


假如发作反常,怎么进行处理?
1.找是什么类型的反常
2.找反常发作的哪一个行代码(是咱们编写的类)
3.在这行代码前加上输出测验句子,测验信息是否正确
4.找到调用办法的哪一行代码,在代码前输出测验句子


版权声明
本文来源于网络,版权归原作者所有,其内容与观点不代表乐橙lc8立场。转载文章仅为传播更有价值的信息,如采编人员采编有误或者版权原因,请与我们联系,我们核实后立即修改或删除。

猜您喜欢的文章